//
//  CallsignFormatter.m
//
//  Created by Willard Myers on 2007.08.30.
//  Copyright 2007 K1GQ. All rights reserved.
//

#import "CallsignFormatter.h"

// Set of characters that may appear in a callsign
static NSCharacterSet* sCallsignCharacterSet;

@implementation CallsignFormatter

+ (void)initialize
{
    sCallsignCharacterSet = [NSCharacterSet characterSetWithCharactersInString:@"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz/"];
}

- (NSString*)stringForObjectValue:(id)obj
{
    if ([obj isKindOfClass: [NSString class]]) {
        return (NSString*)[obj uppercaseString];
    } else {
        return nil;
    }
}

- (BOOL)getObjectValue:(id*)obj forString:(NSString*)string errorDescription:(NSString**)errorString
{
    *obj = [string uppercaseString];
    return YES;
}

- (BOOL)isPartialStringValid:(NSString*)partialString newEditingString:(NSString**)newString errorDescription:(NSString**)error
{
    NSMutableString* ucString = [NSMutableString stringWithCapacity:[partialString length]];
    [ucString setString:[partialString uppercaseString]];
    
    for (NSUInteger i = 0; i < [ucString length]; ++i) {
        unichar c = [ucString characterAtIndex:i];
        if (![sCallsignCharacterSet characterIsMember:c]) {
            [ucString deleteCharactersInRange:NSMakeRange(i, 1)];
        }
    }
    *newString = ucString;
    return NO;
}

@end
