//
//  MessageFormatter.m
//  SkookumLoggerMorse
//
//  Created by Willard Myers on 2009.05.09.
//  Copyright 2009 K1GQ. All rights reserved.
//

#import "MessageFormatter.h"
#import "WinKeyerUsb.h"

@implementation MessageFormatter

- (NSString*)stringForObjectValue:(id)obj
{
    if ([obj isKindOfClass: [NSString class]]) {
        return (NSString*)[obj uppercaseString];
    } else {
        return nil;
    }
}

- (BOOL)getObjectValue:(id*)obj forString:(NSString*)string errorDescription:(NSString**)errorString
{
    *obj = [string uppercaseString];
    return YES;
}

- (BOOL)isPartialStringValid:(NSString**)partialString proposedSelectedRange:(NSRangePointer)proposedSelRange originalString:(NSString*)origString originalSelectedRange:(NSRange)origSelRange errorDescription:(NSString**)error
{
    NSMutableString* ucString = [NSMutableString stringWithCapacity:[*partialString length]];
    [ucString setString:[*partialString uppercaseString]];
    BOOL didDeleteCharacter = NO;
    for (NSUInteger i = 0; i < [ucString length]; ++i) {
        unichar c = [ucString characterAtIndex:i];
        if ([[WinKeyerUsb sharedInstance].morseKeyboardInvertedCharacterSet characterIsMember:c]) {
            [ucString deleteCharactersInRange:NSMakeRange(i, 1)];
            didDeleteCharacter = YES;
            break;
        }
    }
    if (didDeleteCharacter) {
        NSInteger newLocation = proposedSelRange->location - 1;
        if (newLocation < 0) newLocation = 0;
        *proposedSelRange = NSMakeRange(newLocation, origSelRange.length);
    }
    *partialString = ucString;
    return NO;
}

@end
