//
//  MorseKeyboardFormatter.m
//
//  Created by Willard Myers on 2007.08.30.
//  Copyright 2007 K1GQ. All rights reserved.
//

#import "MorseKeyboardFormatter.h"
#import "WinKeyerUsb.h"

@implementation MorseKeyboardFormatter

- (NSString*) stringForObjectValue:(id)obj
{
    if ([obj isKindOfClass: [NSString class]]) {
        return (NSString*)obj;
    } else {
        return nil;
    }
}

- (BOOL) getObjectValue:(id*)obj forString:(NSString*)string errorDescription:(NSString**)errorString
{
    *obj = [string uppercaseString];
    return YES;
}

- (BOOL) isPartialStringValid:(NSString*)partialString newEditingString:(NSString**)newString errorDescription:(NSString**)error
{
    NSMutableString* ucString = [NSMutableString stringWithCapacity:[partialString length]];
    [ucString setString:[partialString uppercaseString]];
    
    for (NSUInteger i = 0; i < [ucString length]; ++i) {
        unichar c = [ucString characterAtIndex:i];
        if (![[WinKeyerUsb morseKeyboardCharacterSet] characterIsMember:c]) {
            [ucString deleteCharactersInRange:NSMakeRange(i, 1)];
        }
    }
    *newString = ucString;
    return NO;
}

/*
- (BOOL)isPartialStringValid:(NSString**)partialStringPtr 
       proposedSelectedRange:(NSRangePointer)proposedSelRangePtr 
              originalString:(NSString*)origString 
       originalSelectedRange:(NSRange)origSelRange 
            errorDescription:(NSString**)error
{
    // If any of the characters in the partial string are not
    // members of the morse keyboard character set, reject the change
    // by setting the partial string and range from the original.
    NSUInteger count = [*partialStringPtr length];
    NSString* partialString = [*partialStringPtr uppercaseString];
    for (NSUInteger i = 0; i < count; ++i) {
        unichar c = [partialString characterAtIndex:i];
        if (![[WinKeyerUsb morseKeyboardCharacterSet] characterIsMember:c]) {
            *partialStringPtr = [origString copy];
            *proposedSelRangePtr = origSelRange;
            return NO;
        }
    }
    return YES;
}
*/
@end
