//
//  PreferencesWinKeyer.m
//
//  Created by Willard Myers on 2008.11.20.
//  Copyright 2008 K1GQ. All rights reserved.
//

#import "PreferencesWinKeyer.h"
#import "WinKeyerConstants.h"

// Not user-accessible
NSString* kWKPaddleEchobackPreferenceKey = @"WKPaddleEchoback";
NSString* kWKSerialEchobackPreferenceKey = @"WKSerialEchoback";
NSString* kWKSpeedPreferenceKey = @"WKSpeed";

// Speed
NSString* kWKSpeedPotMinimumPreferenceKey = @"WKSpeedPotMinimum";
NSString* kWKSpeedPotRangePreferenceKey = @"WKSpeedPotRange";
NSString* kWKFarnsworthSpeedPreferenceKey = @"WKFarnsworthSpeed";
NSString* kWKHSCWSpeedPreferenceKey = @"WKHSCWSpeed";

// Keying
NSString* kWKWeightingPreferenceKey = @"WKWeighting";
NSString* kWKRatioPreferenceKey = @"WKRatio";
NSString* kWKFirstExtensionPreferenceKey = @"WKFirstExtension";
NSString* kWKKeyingCompensationPreferenceKey = @"WKKeyingCompensation";
NSString* kWKAutospacePreferenceKey = @"WKAutospace";
NSString* kWKContestSpacingPreferenceKey = @"WKContestSpacing";
NSString* kWKKeyOut1EnablePreferenceKey = @"WKKeyOut1Enable";
NSString* kWKKeyOut2EnablePreferenceKey = @"WKKeyOut2Enable";

// Paddle
NSString* kWKKeyModePreferenceKey = @"WKKeyMode";
NSString* kWKDitDahPriorityPreferenceKey = @"WKDitDahPriority";
NSString* kWKPaddleHangPreferenceKey = @"WKPaddleHang";
NSString* kWKPaddleSwitchpointPreferenceKey = @"WKPaddleSwitchpoint";
NSString* kWKEnableDitDahMemoryPreferenceKey = @"WKEnableDitDahMemory";
NSString* kWKPaddleSwapPreferenceKey = @"WKPaddleSwap";
NSString* kWKDisablePaddleWatchdogPreferenceKey = @"WKDisablePaddleWatchdog";

// PTT
NSString* kWKPTTEnablePreferenceKey = @"WKPTTEnable";
NSString* kWKPTTLeadTimePreferenceKey = @"WKPTTLeadTime";
NSString* kWKPTTTailTimePreferenceKey = @"WKPTTTailTime";

// Sidetone
NSString* kWKSidetoneEnablePreferenceKey = @"WKSidetoneEnable";
NSString* kWKPaddleOnlySidetonePreferenceKey = @"WKPaddleOnlySidetone";
NSString* kWKSidetoneFrequencyPreferenceKey = @"WKSidetoneFrequency";

// Standalone
NSString* kWKStandaloneCommandSpeedPreferenceKey = @"WKStandaloneCommandSpeed";
NSString* kWKStandaloneEnableMessageBreakPreferenceKey = @"WKStandaloneEnableMessageBreak";
NSString* kWKStandaloneCutSerialNumbersPreferenceKey = @"WKStandaloneCutSerialNumbers";
NSString* kWKStandaloneMessage1PreferenceKey = @"WKStandaloneMessage1";
NSString* kWKStandaloneMessage2PreferenceKey = @"WKStandaloneMessage2";
NSString* kWKStandaloneMessage3PreferenceKey = @"WKStandaloneMessage3";
NSString* kWKStandaloneMessage4PreferenceKey = @"WKStandaloneMessage4";
NSString* kWKStandaloneMessage5PreferenceKey = @"WKStandaloneMessage5";
NSString* kWKStandaloneMessage6PreferenceKey = @"WKStandaloneMessage6";

@implementation PreferencesWinKeyer

+ (void)registerDefaults
{
    // NSLog(@"PreferencesWinKeyer.initialize");
    NSMutableDictionary* defaultsDict = [NSMutableDictionary dictionary];
    NSNumber* no = @NO;
    NSNumber* yes = @YES;
    
    // WK - WinKeyer
    defaultsDict[kWKDisablePaddleWatchdogPreferenceKey] = no;
    defaultsDict[kWKPaddleEchobackPreferenceKey] = no; // no UI
    defaultsDict[kWKKeyModePreferenceKey] = @(PaddleModeIambicA);
    defaultsDict[kWKPaddleSwapPreferenceKey] = no;
    defaultsDict[kWKSerialEchobackPreferenceKey] = yes; // no UI
    defaultsDict[kWKAutospacePreferenceKey] = no;
    defaultsDict[kWKContestSpacingPreferenceKey] = yes;
    defaultsDict[kWKSpeedPreferenceKey] = [NSNumber numberWithUnsignedChar:0]; // Pot controls speed, no UI
    defaultsDict[kWKPaddleOnlySidetonePreferenceKey] = yes;
    defaultsDict[kWKSidetoneFrequencyPreferenceKey] = @(Sidetone400Hz);
    defaultsDict[kWKWeightingPreferenceKey] = [NSNumber numberWithUnsignedChar:0];
    defaultsDict[kWKPTTLeadTimePreferenceKey] = [NSNumber numberWithUnsignedChar:00];
    defaultsDict[kWKPTTTailTimePreferenceKey] = [NSNumber numberWithUnsignedChar:10];
    defaultsDict[kWKSpeedPotMinimumPreferenceKey] = [NSNumber numberWithUnsignedChar:13];
    defaultsDict[kWKSpeedPotRangePreferenceKey] = [NSNumber numberWithUnsignedChar:32];
    defaultsDict[kWKFirstExtensionPreferenceKey] = [NSNumber numberWithUnsignedChar:00];
    defaultsDict[kWKKeyingCompensationPreferenceKey] = [NSNumber numberWithUnsignedChar:00];
    defaultsDict[kWKFarnsworthSpeedPreferenceKey] = [NSNumber numberWithUnsignedChar:10];
    defaultsDict[kWKPaddleSwitchpointPreferenceKey] = [NSNumber numberWithUnsignedChar:50];
    defaultsDict[kWKEnableDitDahMemoryPreferenceKey] = yes;
    defaultsDict[kWKRatioPreferenceKey] = @3.0;
    defaultsDict[kWKDitDahPriorityPreferenceKey] = @(UltimaticPriorityNormal);
    defaultsDict[kWKPaddleHangPreferenceKey] = @(HangTimeShort);
    defaultsDict[kWKKeyOut1EnablePreferenceKey] = yes;
    defaultsDict[kWKKeyOut2EnablePreferenceKey] = no;
    defaultsDict[kWKSidetoneEnablePreferenceKey] = yes;
    defaultsDict[kWKPTTEnablePreferenceKey] = no;
    defaultsDict[kWKHSCWSpeedPreferenceKey] = @"1000 lpm";
    
    defaultsDict[kWKStandaloneCommandSpeedPreferenceKey] = [NSNumber numberWithUnsignedChar:10];
    defaultsDict[kWKStandaloneEnableMessageBreakPreferenceKey] = yes;
    defaultsDict[kWKStandaloneCutSerialNumbersPreferenceKey] = yes;
    defaultsDict[kWKStandaloneMessage1PreferenceKey] = @"Message 1";
    defaultsDict[kWKStandaloneMessage2PreferenceKey] = @"Message 2";
    defaultsDict[kWKStandaloneMessage3PreferenceKey] = @"Message 3";
    defaultsDict[kWKStandaloneMessage4PreferenceKey] = @"Message 4";
    defaultsDict[kWKStandaloneMessage5PreferenceKey] = @"Message 5";
    defaultsDict[kWKStandaloneMessage6PreferenceKey] = @"Message 6";
    
    
    NSUserDefaults* defaults = [NSUserDefaults standardUserDefaults];
    [defaults registerDefaults:defaultsDict];
}

@end
