//
//  WinKeyerUsb.m
//  SkookumMorse
//
//  Created by Willard Myers on 2009.04.23.
//  Copyright 2009 K1GQ. All rights reserved.
//

#import "ORSSerialPort.h"

@interface WinKeyerUsb : NSObject<NSTextDelegate, ORSSerialPortDelegate>
{
    ORSSerialPort* winKeyerSerialPort;
    
    BOOL _sendingState;
    NSUInteger _currentBufferIndex;
    NSUInteger _outputBufferIndex;    
    NSString* _beaconMessage;
    NSTimer* _beaconTimer;
    
    unsigned char _wkStatus;
    BOOL _isHostMode;
}

+ (WinKeyerUsb*)sharedInstance;

@property NSCharacterSet* morseKeyboardInvertedCharacterSet;
@property BOOL isVersion2;
@property NSInteger beaconState;
@property NSInteger hscwState;
@property NSInteger pauseState;
@property NSInteger tuneState;
@property NSString* hisName;
@property NSString* hisCallsign;
@property NSString* keyboardBuffer;
@property NSString* speedString;
@property NSString* versionString;

- (IBAction)stopMessageSending:(id)sender;
- (IBAction)sendMessage:(id)sender;

- (IBAction)tune:(id)sender;

- (BOOL)connect:(NSError**)error;
- (BOOL)isConnected;
- (BOOL)disconnect:(NSError**)error;
- (void)putToWinKeyer:(NSData*)data;

@end

