#import <Cocoa/Cocoa.h>

@class AMSerialPort;
@class AMSerialPortList;
@class MicroHamDevice;

@interface WinkeyerController : NSObject {
    MicroHamDevice* microHamDevice;
    NSData* winkeyResponse;
    
    AMSerialPort* winkeyerPort;
    BOOL connected;
    BOOL isWinKeyer2;
    NSData* wkEEPROM;
    
    bool sendingKeyboardBuffer;
    NSString* keyboardBuffer;
    NSUInteger nextKeyboardBufferCharacterIndex;
    
    NSArray* portStrings;
    NSString* versionString;
    NSString* speedString;
    NSString* connectButtonTitle;
    
    NSString* standaloneMessage1;
    NSString* standaloneMessage2;
    NSString* standaloneMessage3;
    NSString* standaloneMessage4;
    NSString* standaloneMessage5;
    NSString* standaloneMessage6;
    
}

@property AMSerialPort* winkeyerPort;
@property BOOL connected;
@property BOOL isWinKeyer2;
@property bool sendingKeyboardBuffer;
@property (retain) NSString* keyboardBuffer;
@property NSUInteger nextKeyboardBufferCharacterIndex;
@property (retain) NSString* versionString;
@property (retain) NSString* speedString;
@property (retain) NSString* connectButtonTitle;
@property (retain) NSString* standaloneMessage1;
@property (retain) NSString* standaloneMessage2;
@property (retain) NSString* standaloneMessage3;
@property (retain) NSString* standaloneMessage4;
@property (retain) NSString* standaloneMessage5;
@property (retain) NSString* standaloneMessage6;


- (NSString*) portName;
- (void) send;
- (BOOL) connected;
- (void) toggleConnection;
- (BOOL) open:(NSError**)error;
- (void) close;
- (void) readStandalone;
- (void) writeStandalone;
- (void) keyboardBufferDeleteBackward;
- (void) keyboardBufferAppend:(NSString*)editedString;

- (IBAction) abort:(id)sender;
- (IBAction) pause:(id)sender;
- (void) handleInputFromWinkey:(NSData*)input;
- (void) loadWinkeyerDefaults;

@end
